commit e9a2eb86e9dd1f0d3d955bb7c16f2660c773e070
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue May 4 10:55:22 2010 +1000

    xserver 1.7.7
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit ad48184752970541aa153bf2961a2d7da1a910b5
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Apr 21 15:51:20 2010 +1000

    Xext: only update the sprite on pointer events.
    
    A call to miPointerUpdateSprite for the XTEST keyboard may result in a
    NULL pointer dereference in miDCPutUpCursor() when the save buffer is NULL.
    
    XTS test case: Xlib 11 KeymapNotify
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    (cherry picked from commit af170a4ab76d33254dd4e54a33bb410fa1624739)

commit d2229e829d61033141d25fd4486c689c0367b97e
Author: Jeremy Huddleston <jeremyhu@apple.com>
Date:   Tue Apr 27 13:14:47 2010 -0700

    XQuartz GLX: Change around includes for better compatability with different OS versions
    
    Signed-off-by: Jeremy Huddleston <jeremyhu@apple.com>
    (cherry picked from commit 0efd7b8d82a48793341e27d4c224986e0971687c)

commit 86f37fa8627807030cee89c117b05a4a06d2d734
Author: Jeremy Huddleston <jeremyhu@apple.com>
Date:   Wed Apr 21 08:38:53 2010 -0700

    rootless: Add some sanity checking to miPaintWindow
    
    This avoids painting the root window when it isn't actually drawable.
    
    Signed-off-by: Jeremy Huddleston <jeremyhu@apple.com>
    (cherry picked from commit 7b506fdc840aebed6b5acb91437a2cb620b5bddc)

commit 1dbdcfbcbc8105a5878ebce4c74aff7f8071f590
Author: Jeremy Huddleston <jeremyhu@apple.com>
Date:   Sun Apr 18 01:22:27 2010 -0700

    rootless: Remove an unneeded comment
    
    Signed-off-by: Jeremy Huddleston <jeremyhu@apple.com>
    (cherry picked from commit 4d3789c9b3fbe6aad32fcacd964353b612640f27)

commit 67a50803da4eb8d7f827c32776441f34cb726365
Author: Oliver McFadden <oliver.mcfadden@nokia.com>
Date:   Thu Apr 22 10:29:44 2010 +0300

    x-list.c: null-returning function malloc() was called without checking
    
    Signed-off-by: Oliver McFadden <oliver.mcfadden@nokia.com>
    Reviewed-by: Jeremy Huddleston <jeremyhu@apple.com>
    (cherry picked from commit 048d15192af39ba5111882d18a957b6ff4e34cad)

commit 2c94da4e22520f4a3e783db06b73251131382868
Author: Michel Dänzer <daenzer@vmware.com>
Date:   Thu Apr 22 14:16:59 2010 +0200

    EXA: Check sys_ptr isn't NULL before passing it to the UploadToScreen hook.
    
    Fixes https://bugs.freedesktop.org/show_bug.cgi?id=27380 .
    
    Signed-off-by: Michel Dänzer <daenzer@vmware.com>
    Reviewed-by: Alex Deucher <alexdeucher@gmail.com>
    Signed-off-by: Keith Packard <keithp@keithp.com>
    (cherry picked from commit 7b6517526631a65891b806bca30be8f49955d0a8)

commit 7815b02e8d9636b6abbe1f7cb555a1069db2d59f
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Apr 21 11:47:24 2010 +1000

    Revert "mi: don't thrash resources when displaying the software cursor across screens"
    
    This commit leads to a segfault on the very first XTS test case.
    
    Backtrace:
    0: /opt/xorg/bin/Xorg (xorg_backtrace+0x3b) [0x80a33db]
    1: /opt/xorg/bin/Xorg (0x8048000+0x62a75) [0x80aaa75]
    2: (vdso) (__kernel_rt_sigreturn+0x0) [0x5d140c]
    3: /lib/libc.so.6 (0x9bb000+0x73579) [0xa2e579]
    4: /lib/libc.so.6 (realloc+0xe0) [0xa2e830]
    5: /opt/xorg/bin/Xorg (Xrealloc+0x33) [0x80a3f33]
    6: /opt/xorg/bin/Xorg (0x8048000+0x1ab79) [0x8062b79]
    7: /opt/xorg/bin/Xorg (0x8048000+0x1ac4e) [0x8062c4e]
    8: /opt/xorg/bin/Xorg (RegisterExtensionNames+0x2ce) [0x8062fbe]
    9: /opt/xorg/bin/Xorg (AddExtension+0x19a) [0x807bd7a]
    10: /opt/xorg//lib/xorg/modules/extensions/libextmod.so (0x728000+0x1169a)
    [0x73969a]
    11: /opt/xorg/bin/Xorg (InitExtensions+0x85) [0x80c0eb5]
    12: /opt/xorg/bin/Xorg (0x8048000+0x1a51d) [0x806251d]
    13: /lib/libc.so.6 (__libc_start_main+0xe6) [0x9d1bb6]
    14: /opt/xorg/bin/Xorg (0x8048000+0x1a2a1) [0x80622a1]
    Segmentation fault at address 0x10b2d5f8
    
    valgrind output:
    ==5069== Invalid read of size 4
    ==5069==    at 0x80F928D: FreePicture (picture.c:1531)
    ==5069==    by 0x818DDEF: miDCDeviceCleanup (midispcur.c:867)
    ==5069==    by 0x81B97F0: miSpriteDeviceCursorCleanup (misprite.c:968)
    ==5069==    by 0x80995FA: miPointerDeviceCleanup (mipointer.c:292)
    ==5069==    by 0x807973E: CloseDevice (devices.c:840)
    ==5069==    by 0x80799B6: CloseDownDevices (devices.c:933)
    ==5069==    by 0x8062705: main (main.c:309)
    ==5069==  Address 0x4cce844 is 12 bytes inside a block of size 84 free'd
    ==5069==    at 0x40057F6: free (vg_replace_malloc.c:325)
    ==5069==    by 0x80A3DE0: Xfree (utils.c:1154)
    ==5069==    by 0x80F9332: FreePicture (picture.c:1576)
    ==5069==    by 0x80FBB4B: PictureDestroyWindow (picture.c:69)
    ==5069==    by 0x810B1A3: damageDestroyWindow (damage.c:1840)
    ==5069==    by 0x80864F1: FreeWindowResources (window.c:846)
    ==5069==    by 0x8086812: DeleteWindow (window.c:925)
    ==5069==    by 0x806B53E: FreeClientResources (resource.c:806)
    ==5069==    by 0x806B60F: FreeAllResources (resource.c:823)
    ==5069==    by 0x80626E4: main (main.c:299)
    ==5069==
    ==5069== Invalid write of size 4
    ==5069==    at 0x80F9295: FreePicture (picture.c:1531)
    ==5069==    by 0x818DDEF: miDCDeviceCleanup (midispcur.c:867)
    ==5069==    by 0x81B97F0: miSpriteDeviceCursorCleanup (misprite.c:968)
    ==5069==    by 0x80995FA: miPointerDeviceCleanup (mipointer.c:292)
    ==5069==    by 0x807973E: CloseDevice (devices.c:840)
    ==5069==    by 0x80799B6: CloseDownDevices (devices.c:933)
    ==5069==    by 0x8062705: main (main.c:309)
    ==5069==  Address 0x4cce844 is 12 bytes inside a block of size 84 free'd
    ==5069==    at 0x40057F6: free (vg_replace_malloc.c:325)
    ==5069==    by 0x80A3DE0: Xfree (utils.c:1154)
    ==5069==    by 0x80F9332: FreePicture (picture.c:1576)
    ==5069==    by 0x80FBB4B: PictureDestroyWindow (picture.c:69)
    ==5069==    by 0x810B1A3: damageDestroyWindow (damage.c:1840)
    ==5069==    by 0x80864F1: FreeWindowResources (window.c:846)
    ==5069==    by 0x8086812: DeleteWindow (window.c:925)
    ==5069==    by 0x806B53E: FreeClientResources (resource.c:806)
    ==5069==    by 0x806B60F: FreeAllResources (resource.c:823)
    ==5069==    by 0x80626E4: main (main.c:299)
    
    XTS test case: Xproto pAllocColor
    
    This reverts commit 00b8b7ad61b6f818271fb4d1e383113170309d72.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit ba2ba32e04f9002dbb60f10e174ac63d16e5f507
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Apr 21 09:17:26 2010 +1000

    xserver 1.7.6.902
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit e8fae02f19d6d75ac3edbea2f5af8d250dcfbde3
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Apr 14 17:43:22 2010 +1000

    dix: Fix crash in DeliverGrabbedEvents.
    
    If both devices are synchronously grabbed, first with a GrabPointer, then
    with a GrabKeyboard (GrabModeSync on both), sync.other of each device points
    to the grab of the respective other device.
    
    If the keyboard is then thawed through a AllowSome request, the VCK's
    sync.other is reset to NULL. Subsequently, an event on the VCP would crash
    the server when dereferencing sync.other on the VCP.
    
    The check's purpose is to compare if the other device is grabbed by the same
    client, which should be checked by accessing (dev->deviceGrab->grab->resource).
    A check of the server-1.3 sources confirms that.
    
    XTS test case: Xlib13 XAllowEvents 20.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Keith Packard <keithp@keithp.com>
    Signed-off-by: Keith Packard <keithp@keithp.com>
    (cherry picked from commit 9ddbb03fa56aa73c3f417d8ee6433e45b94445b3)

commit aa6a18fdebf444084c27e4a7f3eef7d93f9929b0
Author: Cyril Brulebois <kibi@debian.org>
Date:   Sat Apr 17 01:31:14 2010 +0200

    exa: handle pixmap create/destroy in lower layers
    
    - Pixmaps that are created during a fallback are automatically prepared access.
    - During the fallback accelerated ops are blocked to prevent new/scratch gc's
      from triggering accelerated ops on mapped pixmaps.
    - A few cases of incorrect wrapping (on the top level pointer instead of
      between damage and (w)fb) have been removed.
    
    Signed-off-by: Maarten Maathuis <madman2003@gmail.com>
    Acked-by: Michel Dänzer <michel@daenzer.net>
    Signed-off-by: Keith Packard <keithp@keithp.com>
    (cherry picked from commit 342f3689d17256c92cbfee079d24501d27aa1153)
    
    Conflicts:
    
    	exa/exa_mixed.c
    
    Debian bug#576816 <http://bugs.debian.org/576816>
    
    Tested-by: Arthur Marsh <arthur.marsh@internode.on.net>
    Signed-off-by: Cyril Brulebois <kibi@debian.org>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit acbcb77bf6acf513660b4a9df8d20a5c04f1c865
Author: Julien Cristau <jcristau@debian.org>
Date:   Tue Apr 6 11:51:53 2010 +0200

    XGE: don't register an extension event
    
    The GenericEvent is a core event, we never send an extension event, so
    don't reserve an id for one.
    
    Signed-off-by: Julien Cristau <jcristau@debian.org>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Keith Packard <keithp@keithp.com>
    (cherry picked from commit fc5d76740851725e3788c68e14474a012a205892)
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit c52b9e143da294e787d93ddbd7b9b620a3a892e2
Author: Julien Cristau <jcristau@debian.org>
Date:   Tue Apr 13 22:28:36 2010 +0200

    vfb: add a name and type to the pointer and keyboard
    
    Fixes a crash in XIQueryDevice which calls strlen on a NULL pointer.
    
     #0  strlen () at ../sysdeps/x86_64/strlen.S:31
     #1  0x00000000004c16ed in SizeDeviceInfo (dev=0x969bd0)
         at ../../Xi/xiquerydevice.c:204
     #2  0x00000000004c1a01 in ProcXIQueryDevice (client=0xa57510)
         at ../../Xi/xiquerydevice.c:98
    
    Debian bug#575905 <http://bugs.debian.org/575905>
    
    Reported-by: "Bernhard R. Link" <brlink@debian.org>
    Signed-off-by: Julien Cristau <jcristau@debian.org>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    (cherry picked from commit 0e7703f9b1927328954a2fc87aac6be244819329)
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 9a9a19ac4ecdab0e2602d70354145545de37f3c5
Author: Pierre-Loup A. Griffais <pgriffais@nvidia.com>
Date:   Wed Apr 7 13:52:47 2010 -0700

    mi: don't thrash resources when displaying the software cursor across screens
    
    This changes the DC layer to maintain a persistent set of GCs/pixmaps/pictures
    for each pScreen instead of failing to thrash between them when changing
    screens.
    
    Signed-off-by: Pierre-Loup A. Griffais <pgriffais@nvidia.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    (cherry picked from commit 00b8b7ad61b6f818271fb4d1e383113170309d72)
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit ff02e0e4a2f33131520bc3bf7d6621a301c5296d
Author: Tim Yamin <plasm@roo.me.uk>
Date:   Mon Mar 8 12:45:15 2010 +1000

    dix: fix cursor screen check for xinerama setups.
    
    The de-duplication of CheckPhysLimits 942eae6868b8b0f343b6a added a
    condition that is invalid for a Xinerama setup. pScreen is invalid for the
    Xinerama case, so comparing it to anything is a bad idea.
    
    Signed-off-by: Tim Yamin <plasm@roo.me.uk>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    (cherry picked from commit 5f31e2196179f8db3170d65a17d8ad40da1acb0d)
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 8616c5eb756aeb408545da5d186ad28909574dcb
Author: Jeremy Huddleston <jeremyhu@apple.com>
Date:   Thu Apr 15 10:55:53 2010 -0700

    XQuartz GLX: Don't let garbage enter our pixel request
    
    https://bugs.freedesktop.org/show_bug.cgi?id=27654
    
    Signed-off-by: Jeremy Huddleston <jeremyhu@apple.com>
    (cherry picked from commit 5b0faf355465c9f21ad96e0ed266fbdbc29efb5b)

commit 0dd9d27eaacc02f968ce98749a1696189274a8f8
Author: Jeremy Huddleston <jeremyhu@apple.com>
Date:   Wed Apr 14 09:06:04 2010 -0700

    XQuartz: Fix possible NULL dereference in ListenOnOpenFD
    
    <rdar://problem/7862319>
    
    Signed-off-by: Jeremy Huddleston <jeremyhu@apple.com>
    Reviewed-by: Marc Majka <majka@apple.com>
    (cherry picked from commit fe7778e58e099d353689755ed2f5aa440569ebe3)

commit 3d7d699e3a024c870bca9cb0e1c922dbb87d5316
Author: Jeremy Huddleston <jeremyhu@apple.com>
Date:   Tue Apr 13 14:33:49 2010 -0700

    XQuartz: Localization update
    
    Signed-off-by: Jeremy Huddleston <jeremyhu@apple.com>
    (cherry picked from commit 206531f75cd41c034e89fdfbc75ab0910682eef8)

commit e7ab6537c2745decb7143c5e4eb31440be262fd0
Author: Jeremy Huddleston <jeremyhu@apple.com>
Date:   Fri Apr 9 16:19:43 2010 -0700

    XQuartz: Add a GUI preference for the Alt / Mode_switch toggle
    
    Signed-off-by: Jeremy Huddleston <jeremyhu@apple.com>
    Reviewed-by: Kevin Van Vechten <kvv@apple.com>
    (cherry picked from commit 59edde7c28db2d3174a5813a0af334e4ead2082f)

commit 30f4c7e4fb20f9d465e6a56db937c4af48885161
Author: Jeremy Huddleston <jeremyhu@apple.com>
Date:   Fri Apr 9 13:33:06 2010 -0700

    XQuartz: Customize the NSDefaults id in the man file.
    
    Signed-off-by: Jeremy Huddleston <jeremyhu@apple.com>
    Reviewed-by: Kevin Van Vechten <kvv@apple.com>
    (cherry picked from commit 5600f7f001529b3afdee95546aec212a70d6a5b2)

commit a75e4be03c7888a86a9b76de11e39ff8f9f7ac86
Author: Jeremy Huddleston <jeremyhu@apple.com>
Date:   Fri Apr 9 13:29:34 2010 -0700

    XQuartz: Add a defaults option to toggle Alt / Mode_switch
    
    See option_sends_alt in Xquartz(1)
    
    Signed-off-by: Jeremy Huddleston <jeremyhu@apple.com>
    Reviewed-by: Kevin Van Vechten <kvv@apple.com>
    (cherry picked from commit 840d12c7a6ac6a974da185045215ce944a61fab6)

commit af86a25009c337954f61475196a0092712cab1e1
Author: Jeremy Huddleston <jeremyhu@apple.com>
Date:   Mon Apr 5 16:54:22 2010 -0700

    XQuartz: Blacklist some oddball legacy Mac keycodes that break wine
    
    http://xquartz.macosforge.org/trac/ticket/295
    
    Signed-off-by: Jeremy Huddleston <jeremyhu@apple.com>
    Reviewed-by: Kevin Van Vechten <kvv@apple.com>
    (cherry picked from commit d6f160510a50d4c4eaa48c9c69a5ddda0d50052c)

commit 501c0ee63570da7501d047c51c40a2568af1df08
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Apr 12 11:51:21 2010 +1000

    xserver 1.7.6.901
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 8c0548bc34dead67bc944a59664be6254be928bd
Author: Tiago Vignatti <tiago.vignatti@nokia.com>
Date:   Thu Apr 1 18:57:50 2010 +0300

    xfree86: die gracefully in the vga arbiter if AddScreen fails
    
    vga arbiter will be locked in one device while AbortDDX will call LeaveVT
    routines from the other device. Fail!
    
    Signed-off-by: Tiago Vignatti <tiago.vignatti@nokia.com>
    Reviewed-by: Keith Packard <keithp@keithp.com>
    Signed-off-by: Keith Packard <keithp@keithp.com>
    (cherry picked from commit b9ad452ec92a7dcbed680acb3f3b8ec29fa660df)
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit e7154e9375e6b624db01a787d9ec6c8cedc2eb81
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Mar 17 14:32:38 2010 +1000

    dix: if owner-events is true for passive grabs, add the window mask (#25400)
    
    A client requesting a GrabModeSync button grab, owner-events true, with only
    the ButtonRelease mask set would never receive the press event even if the
    grab window had the ButtonPress mask set.
    
    The protocol requires that if owner-events is true, then the delivery mask
    is the combination of the grab mask + the window event mask.
    
    X.Org Bug 25400 <http://bugs.freedesktop.org/show_bug.cgi?id=25400>
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Tested-by: Jim Ramsay <i.am@jimramsay.com>
    Signed-off-by: Keith Packard <keithp@keithp.com>
    (cherry picked from commit 1c612acca8568fcdf9761d23f112adaf4d496f1b)
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit d33b3bf41b92e088e7aacbbcb01df18bae50baa8
Author: Michel Dänzer <daenzer@vmware.com>
Date:   Mon Mar 22 18:01:17 2010 +0100

    Xext: Fix cursor reference counting hazard.
    
    Make sure the reference count of the new cursor is increased before the old
    one is decreased, otherwise bad things will happen if they're one and the
    same and the reference count is 1 initially. Not sure this can actually happen
    here, but better safe than sorry.
    
    Signed-off-by: Michel Dänzer <daenzer@vmware.com>
    Reviewed-by: Roland Scheidegger <sroland@vmware.com>
    Signed-off-by: Keith Packard <keithp@keithp.com>
    (cherry picked from commit 3083c5d0c4386cdd7083b7a83ac72fdad2f1e61e)
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 4520d5cc5faccc5a3b623d4c7e61068431a927cc
Author: Mikhail Gusarov <dottedmag@dottedmag.net>
Date:   Tue Mar 23 01:03:53 2010 +0600

    kdrive: Bump evdev maxKeycode
    
    There are keycodes > 193 in evdev, e.g. KEY_WIMAX which is 246 .
    
    Signed-off-by: Mikhail Gusarov <dottedmag@dottedmag.net>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Adam Jackson <ajax@nwnk.net>
    Signed-off-by: Keith Packard <keithp@keithp.com>
    (cherry picked from commit e086b99c1f5ce351b578de7cd9f616bc79d6cf64)
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 48f8a7d1259a559b3cc774598b5d0d6edbc984bc
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Mar 22 09:20:49 2010 +1000

    configure: Always define XINPUT.
    
    This define was removed in e251c9e75afdc "Remove all traces of #ifdef XINPUT
    and the matching bits from the configure.ac". Drivers that support multiple
    server versions and still check for ifdef XINPUT now always build without
    XINPUT support if they're calling XORG_DRIVER_CHECK_EXT(XINPUT, inputproto).
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Dan Nicholson <dbn.lists@gmail.com>
    (cherry picked from commit 6389405b56d2221d8a7b80c4bb3bd3b4e1a29bab)
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 1130a0def920fdeb064cd5958d59ee2882a79d28
Author: Jeremy Huddleston <jeremyhu@freedesktop.org>
Date:   Tue Mar 23 10:37:36 2010 -0700

    XKB: Fix garbage initialization
    
    XkbEnableDisableControls set extra garbage bits on the xkbControlsNotify
    changedControls mask because it was uninitialized on the stack.
    
    Found by clang
    
    Signed-off-by: Jeremy Huddleston <jeremyhu@apple.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    (cherry picked from commit 8311cd5f89ca6781842bb24671b8122cdf8be148)
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit ff5af4dc2d14c1bf2676f69e7dcee62eb9a08f78
Author: Paulo Ricardo Zanoni <pzanoni@mandriva.com>
Date:   Thu Mar 11 14:28:18 2010 -0300

    dix: be more verbose when we run out of opcodes
    
    If we run out of opcodes, nothing is print on the log, making the
    problem hard to debug. In the current Xserver, if you enable some
    extensions like multibuffer (+2 events) and use nvidia binary driver (+5
    events) you can run out of opcode numbers.
    
    Signed-off-by: Paulo Ricardo Zanoni <pzanoni@mandriva.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Julien Cristau <jcristau@debian.org>
    Signed-off-by: Keith Packard <keithp@keithp.com>
    (cherry picked from commit a9fe7cfa77ccee64d68732dc3f37d35cbfc27a65)
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 2350035463bcfb6d80249b55ce392a154a8d91da
Author: Pierre-Loup A. Griffais <pgriffais@nvidia.com>
Date:   Fri Apr 2 12:48:21 2010 -0700

    Don't keep a pointer to a possibly freed cursor when changing screens, preventing a crash in xf86CursorEnableDisableFBAccess() trying to restore it.
    
    Signed-off-by: Pierre-Loup A. Griffais <pgriffais@nvidia.com>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    (cherry picked from commit 6b09f66d8c6ebcee70382b5cca1ba82b68f20afa)
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 2297ad916a15a116e92f2549f59b222449f08b89
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Jan 8 15:18:41 2010 +1000

    dix: EventToCore needs to copy the root window too.
    
    This value isn't actually set for normal events but it saves us some work
    for the record extension support.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Keith Packard <keithp@keithp.com>
    Signed-off-by: Keith Packard <keithp@keithp.com>
    (cherry picked from commit b4baab90c0d98bef98d485682d4a69a327a380d6)
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 49a2b55e0e1e265c1393c04c9df8e73f30dccd33
Author: Jeremy Huddleston <jeremyhu@apple.com>
Date:   Sun Mar 28 13:46:23 2010 -0700

    XQuartz: Re-query dixScreenOrigins as the value could've changed.
    
    Fix a regression in 9c9c3a85b094a3c7b2763a572715d710325091aa
    
    Signed-off-by: Jeremy Huddleston <jeremyhu@apple.com>
    Acked-by: Adam Jackson <ajax@redhat.com>
    (cherry picked from commit 28a5f14b4089dccb8045cc4fdc923542a73dd22d)

commit 68319e7f0755a7d36ed1544214dceae0afa05b76
Author: Jeremy Huddleston <jeremyhu@apple.com>
Date:   Thu Mar 25 22:15:58 2010 -0700

    XQuartz: Workaround weird key data reported on some layouts
    
    This should make 'Unicode Hex Input' work as an input layout.
    
    Signed-off-by: Jeremy Huddleston <jeremyhu@apple.com>
    Acked-by: Adam Jackson <ajax@redhat.com>
    (cherry picked from commit 339207be6f184cc783076fc7e2cc12f92f57f2ba)

commit 2ad8aae749fe08f139e3046e923da8233b9a7cd5
Author: Roland Scheidegger <sroland@vmware.com>
Date:   Fri Mar 12 16:53:30 2010 +0100

    hw/xfree86: move reference counting out of the UseHWCursor[ARGB] functions
    
    The problem is that the xf86_use_hw_cursor(_argb) functions may get this
    correctly now, some drivers will replace these generic versions with their
    own functions. It is pretty insane to expect them to do reference counting
    of the cursor (as an example, look at driver/xf86-video-vmware to see how
    that looks like as a workaround). There are even places in xserver itself
    which replace these two functions.
    The segfaults if no reference counting is done are caused because the
    reference count of the cursor reached zero, hence the cursor was freed,
    however xf86CursorEnableDisableFBAccess() brought it back to life from
    the dead (from the SavedCursor).
    This patch hence adds reference counting in xf86CursorSetCursor. As per Michel
    Daenzer's suggestion, also free the cursor upon xf86CursorCloseScreen.
    In theory with this it should be possible to remove the reference
    counting in the UseHwCursor functions I think, though it should also be
    safe to keep them.
    
    Signed-off-by: Roland Scheidegger <sroland@vmware.com>
    Reviewed-by: Michel Dänzer <michel@daenzer.net>
    Signed-off-by: Keith Packard <keithp@keithp.com>
    (cherry picked from commit 67a8c659f25218904bae64aac6e98e326c90330b)

commit e481a4912bc53a09429002b2bf8c321b516d236f
Author: Tomas Carnecky <tom@dbservice.com>
Date:   Mon Mar 22 11:20:15 2010 -0700

    Fix typos in the swap functions
    
    This should fix bug #3539.
    
    Signed-off-by: Tomas Carnecky <tom@dbservice.com>
    Signed-off-by: Ian Romanick <ian.d.romanick@intel.com>
    Reviewed-by: Keith Packard <keithp@keithp.com>
    Signed-off-by: Keith Packard <keithp@keithp.com>
    (cherry picked from commit 0c2fde5c8ad6e94b4ed1588aa93256a2b64f74d9)

commit 2fa794f246b0224c458295a271a4246b52eb75c0
Author: Peter Harris <pharris@opentext.com>
Date:   Tue Mar 23 12:08:19 2010 -0400

    Fix crash when all glyphs of a given depth are freed, but not all glyphsets
    
    This is how the crash can be triggered with only two clients on the system:
    Client A: (already running)
    Client B: Connect
    Client B: CreateGlyphSet(depthN)
    Client A: Disconnect
    Server: free globalGlyphs(depthN)
    Client B: AddGlyphs(depthN)
    Server: SEGV
    
    This crash was introduced with the FindGlyphsByHash function
    in 516b96387b0e57b524a37a96da22dbeeeb041712. Before that revision,
    ResizeGlyphSet was always called before FindGlyphRef, which would
    re-create globalGlyphs(depthN) if necessary.
    
    X.Org Bug 20718 <http://bugs.freedesktop.org/show_bug.cgi?id=20718>
    
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    Signed-off-by: Peter Harris <pharris@opentext.com>
    Signed-off-by: Keith Packard <keithp@keithp.com>
    (cherry picked from commit 185185eeb44a277c324be0f58a4b4a469b56b69b)

commit 4c85c3815a6f1698e91d2043d51a716948f8c1df
Author: Jeremy Huddleston <jeremyhu@apple.com>
Date:   Fri Mar 19 17:24:27 2010 -0700

    XQuartz: Constrain the pointer to the updated display bounds on display reconfigure.
    
    http://xquartz.macosforge.org/trac/ticket/346
    (cherry picked from commit ed31d50b5f7f25e4db986711699704e615b8afcb)

commit b226618f55a5393e32f339a963ae7aaf145c51a4
Author: Jeremy Huddleston <jeremyhu@freedesktop.org>
Date:   Sat Mar 20 11:03:28 2010 -0700

    XQuartz: pbproxy: Make standalone xpbproxy respect the launchd prefix
    
    Signed-off-by: Jeremy Huddleston <jeremyhu@freedesktop.org>
    (cherry picked from commit 38215cc43e4c012588c7a50344b8fe368d1252cc)

commit 088777f2b683d61d948cf346564a73b048da1ea2
Author: Jeremy Huddleston <jeremyhu@freedesktop.org>
Date:   Sat Mar 20 03:28:57 2010 -0700

    XQuartz: xpbproxy: Cleanup xpbproxy threading
    
    Confine xpbproxy to a single thread
    Runs inside its own CFRunLoop
    
    Signed-off-by: Jeremy Huddleston <jeremyhu@freedesktop.org>
    (cherry picked from commit 69869d79f4c21eb385ff3c64bac649d93c7dd2ad)

commit b3f4a9a64be4b6bcc81f13cf9677a486b42dd2b4
Author: Jeremy Huddleston <jeremyhu@apple.com>
Date:   Fri Mar 19 17:23:12 2010 -0700

    XQuartz: Minor cleanup
    
    Move RandRInit to where it will need to be (not yet implemented)
    
    Signed-off-by: Jeremy Huddleston <jeremyhu@apple.com>
    (cherry picked from commit 7da4f9df9c6490e3e604c170415d5af2d8c8ff29)

commit b444205399c236c21c68e2dda32ce51497dcd7e4
Author: Jeremy Huddleston <jeremyhu@freedesktop.org>
Date:   Fri Mar 19 15:26:50 2010 -0700

    XQuartz: GLX: Fix Availability for Tiger ppc workaround
    
    Signed-off-by: Jeremy Huddleston <jeremyhu@freedesktop.org>
    (cherry picked from commit 88baffc25a193c7c7154a94a687e7cb0f8b180ba)

commit c552ec12f9112901d5266c00fb3aaf4e06f5d614
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Mar 17 10:49:28 2010 +1000

    xserver 1.7.6
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 63ef872068299aa2ea6bfd7d11935c222cc1e102
Author: Jeremy Huddleston <jeremyhu@apple.com>
Date:   Tue Mar 16 11:40:53 2010 -0700

    Revert "XQuartz: Explicitly pass a bellProc to make XBell() work again."
    
    I'm not quite sure why this was necessary, but DDXRingBell is being called
    from CoreKeyboardBell, so we don't need a separate bellProc which would
    result in multiple rings.
    
    This reverts commit 7e7e7935eeb86b5990664a662471800cfd2e7ce0.
    
    Conflicts:
    
    	hw/xquartz/quartzKeyboard.c
    
    Signed-off-by: Jeremy Huddleston <jeremyhu@apple.com>

commit 31292a7c775e4a249926140a86bc19c3805cdd96
Author: Jeremy Huddleston <jeremyhu@apple.com>
Date:   Wed Feb 10 15:52:14 2010 -0800

    XQuartz: Use an empty xkb keymap by default
    
    Signed-off-by: Jeremy Huddleston <jeremyhu@apple.com>
    (cherry picked from commit 5172253bae3b9867118c6717434e73c173acd5e9)

commit 5b4fabb910eefb393eb3bfb45df5e63fdeb71f26
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Mar 15 08:44:01 2010 +1000

    configure: restore SHA1_LIB for XSERVER_SYS_LIBS
    
    Accidentally removed in ff5fb43a4b38c707a, caused by
    a botched merge when cherry-picking 178da6534fe7ab4b99fb.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 5a2b3f36a05d1e0fcfd1b0f85d6584478ba24eda
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Mar 12 16:53:06 2010 +1000

    xserver 1.7.5.902
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit c25b34fe61cb3fc7c3583a8ccf62c470cc8ead06
Merge: 3ae6a37 ff5fb43
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Mar 12 16:37:28 2010 +1000

    Merge branch 'server-1.7-nominations' into server-1.7-branch

commit ff5fb43a4b38c707a1a9948ace621a62b5b2457a
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Mar 12 14:39:19 2010 +1000

    Xext: Link to external libraries when necessary.
    
    Although the DDX should be linked to the necessary libraries, we may
    also need to pull them in directly to the module to ensure the symbols
    are resolved at runtime. Should fix this bug with XSELINUX:
    
    /usr/bin/X: symbol lookup error:
    /usr/lib64/xorg/modules/extensions/libextmod.so: undefined symbol:
    is_selinux_enabled
    
    -v2: use _LIBADD instead of _LIBS; remove SELINUX_LIBS from
         XSERVER_SYS_LIBS as it should only be needed in extmod.
    
    Signed-off-by: Dan Nicholson <dbn.lists@gmail.com>
    Signed-off-by: Eamon Walsh <ewalsh@tycho.nsa.gov>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    (cherry picked from commit 178da6534fe7ab4b99fb87925c04e6f963c88583)
    
    Conflicts:
    
    	configure.ac

commit a69c7a4c539f933df3f6aa5444cdde95e4d5698a
Author: Daniel Stone <daniel@fooishbar.org>
Date:   Thu Mar 11 14:19:04 2010 +0200

    Record: Avoid duplicates from replaying frozen events
    
    Reintroduce a check which used to be there in the old
    ProcessKeyboardEvent/ProcessPointerEvent codepath, which avoids us
    recording events subject to a grab twice: once when it's first processed
    in EnqueueEvent, and then again when it's thawed and being replayed.
    
    This required a tiny amount of code motion to expose syncEvents.
    
    Signed-off-by: Daniel Stone <daniel@fooishbar.org>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    (cherry picked from commit a2ea8c2f2cc53607d57d60f41c879380ea70cd02)
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 3ae6a3779d9040a4d7c3e1b7901117e24e0d3ecf
Author: Dave Airlie <airlied@redhat.com>
Date:   Wed Mar 10 16:07:09 2010 +1000

    dri2: return FALSE not BadValue.
    
    With 1.7 if you try and send a DRI2Connect with this value set
    to anything but 0, the server will segfault due to the strlen
    in the function this returns to, since BadValue != FALSE.
    
    Fixed via other work in 1.8.
    
    Signed-off-by: Dave Airlie <airlied@redhat.com>

commit 2086e4920a16248aa150114236dfb0637c20559a
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Mar 9 09:42:42 2010 +1000

    Revert "dix: Use DeliverGrabbedEvent for implicit passive grabs (#25400)"
    
    Reported-by: Florian Mickerl <florian@mickler.org>
    "this regresses my desktop. fluxbox is not able to move the windows around
    anymore. also popup of context-menue does not work. (well sometimes it does,
    but then the fluxbox-keyboard-shortcuts do not work)"
    
    This reverts commit 351d11fd466fae731df860a6ff4cf50ad565f43f.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 1242e494c8abc25d51fa0f8120ba353ffcf7be08
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Fri Mar 5 09:27:13 2010 +1000

    xserver 1.7.5.901
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit d023b78c739672894d6b8196d91129845614e369
Author: Keith Packard <keithp@keithp.com>
Date:   Thu Feb 25 11:37:05 2010 -0800

    Allow for missing or disabled compat_output
    
    When the compat output is missing (I don't think this is actually
    possible), or is disabled (and hence has no crtc), we would like to
    avoid dereferencing NULL pointers. This patch creates inline functions
    to extract the current compat output, crtc or associated RandR crtc
    structure, carefully checking for NULL pointers everywhere.
    
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    Signed-off-by: Keith Packard <keithp@keithp.com>
    (cherry picked from commit de86a3a3448f0a55c1cd99aee9ea80070a589877)

commit 7def5cdf7dce0ace34e0befb3a9730e1bd607b61
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 4 15:42:47 2010 +1000

    configure: move SELINUX_LIBS to XSERVER_SYS_LIBS
    
    All ddxs require linking against selinux if enabled.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Dan Nicholson <dbn.lists@gmail.com>
    Reviewed-by: Eamon Walsh <ewalsh@tycho.nsa.gov>
    Signed-off-by: Keith Packard <keithp@keithp.com>
    (cherry picked from commit 1c2abec479cfbac9aeadc121af0825d368317658)
    
    Conflicts:
    
    	configure.ac

commit 402668251135b63b7329722397fe7885e065f27c
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 4 15:41:53 2010 +1000

    configure: move libselinux requirement up to the common section.
    
    Let's have all version-specific requirements in one block.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Dan Nicholson <dbn.lists@gmail.com>
    Reviewed-by: Eamon Walsh <ewalsh@tycho.nsa.gov>
    Signed-off-by: Keith Packard <keithp@keithp.com>
    (cherry picked from commit cab99b947c66a42dbf8a906bdb02e23aa7cab519)
    
    Conflicts:
    
    	configure.ac

commit 351d11fd466fae731df860a6ff4cf50ad565f43f
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Feb 25 12:49:21 2010 +1000

    dix: Use DeliverGrabbedEvent for implicit passive grabs (#25400)
    
    A client requesting a GrabModeSync button grab, owner-events true, with only
    the ButtonRelease mask set would never receive the press event even if the
    grab window had the ButtonPress mask set.
    
    The protocol requires that if owner-events is true, then the delivery mask
    is the combination of the grab mask + the window event mask.
    
    DeliverGrabbedEvents does this already for us, checking first the delivery
    based on owner_events and then based on the grab mask. AFAICT, the device
    cannot enter the states FREEZE_BOTH_NEXT_EVENT or FREEZE_NEXT_EVENT that
    would be handled by DGE in any possible path here.
    
    Bonus point - CheckPassiveGrabsOnWindows suddenly becomes a lot lesss
    complicated.
    
    X.Org Bug 25400 <http://bugs.freedesktop.org/show_bug.cgi?id=25400>
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Keith Packard <keithp@keithp.com>
    Signed-off-by: Keith Packard <keithp@keithp.com>
    (cherry picked from commit cf72b5437d2d620521279077a29c5df6d0fbb576)
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 8f743f17ed0076d10d6c60fe8bdf3f54d3432ae5
Author: Alan Coopersmith <alan.coopersmith@sun.com>
Date:   Mon Feb 15 17:42:11 2010 -0800

    Solaris xf86OSRingBell() off-by-one error in filling iov[] array
    
    When generating sound buffers for /dev/audio bells, insert waveform
    for beep *or* silence, but not both, so we don't write one entry past
    the end of the iov buffer when the final bit of soundwave ends up in
    the final entry allocated in the iov array.
    
    Fixes OpenSolaris bug 6894890:
     http://bugs.opensolaris.org/bugdatabase/view_bug.do?bug_id=6894890
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@sun.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Adam Jackson <ajax@redhat.com>
    Signed-off-by: Keith Packard <keithp@keithp.com>

commit d35e08b6db911c404d7baf680dab30e8a6831bc4
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Feb 18 16:00:15 2010 +1000

    dix: remove now-erroneous comment about frozen slave devices.
    
    A direct grab on a slave device through XI2 detaches it, regardless of
    whether the grab is sync or async. So this comment doesn't apply to XI2
    anyway.
    
    For XI1, aside from your life being miserable already, it doesn't matter as
    XI1 does not have a concept of attachment. You can freeze a device and if
    you don't freeze _all_ other devices at the same time, the master device can
    still happily send events to the client.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Adam Jackson <ajax@redhat.com>
    (cherry picked from commit c0d941913199ed251fceab62fcf65437f6f9bd31)
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 11c27f261efc5b7a8594ad2de7bed4339f2a62ce
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Feb 15 16:32:16 2010 +1000

    dix: try to ring the bell even if the current device doesn't have one. (#24503)
    
    Evdev devices do not have the bell proc set, but XTEST devices do. By
    exiting early, the bell only rings if the last keyboard used was the XTEST
    keyboard and hence the bell proc is still set on the master but not if an
    evdev keyboard was used last.
    
    The better approach here is to try to ring the bell on all devices attached
    to this master device in case one or more actually do produce an audible
    sound. That's also XKB's behaviour if XkbUseCoreKbd is specified as device
    identifier.
    
    X.Org Bug 24503 <http://bugs.freedesktop.org/show_bug.cgi?id=24503>
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    (cherry picked from commit 758f6971750ed507e64eee817d720a77181439f2)
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 1f96c0371845d5904b7d4c8fe71ee545b649faca
Author: Eamon Walsh <ewalsh@tycho.nsa.gov>
Date:   Wed Feb 3 15:40:47 2010 -0500

    xselinux: Bump extension minor version.
    
    Changes introduced in this version:
    	- 3 window-related requests now handle pixmaps also.
    
    Signed-off-by: Eamon Walsh <ewalsh@tycho.nsa.gov>
    Reviewed-by: Keith Packard <keithp@keithp.com>
    (cherry picked from commit db4f676f25c6d8e58263d5151942be730592d444)

commit dd9573d4086ca24c59a99a0a2019bf20c61b0f64
Author: Eamon Walsh <ewalsh@tycho.nsa.gov>
Date:   Wed Feb 3 15:38:57 2010 -0500

    xselinux: Rename window-related requests that now support pixmaps.
    
    Renamed requests:
    	SetWindowCreateContext -> SetDrawableCreateContext
    	GetWindowCreateContext -> GetDrawableCreateContext
    	GetWindowContext -> GetDrawableContext
    
    Signed-off-by: Eamon Walsh <ewalsh@tycho.nsa.gov>
    Reviewed-by: Keith Packard <keithp@keithp.com>

commit 7cec236a03917841131941ce97bd1dfd4a027327
Author: Eamon Walsh <ewalsh@tycho.nsa.gov>
Date:   Wed Feb 3 15:08:40 2010 -0500

    xselinux: Allow GetWindowContext to be used for pixmaps as well.
    
    Signed-off-by: Eamon Walsh <ewalsh@tycho.nsa.gov>
    Reviewed-by: Keith Packard <keithp@keithp.com>

commit 1b6f498b84de7f79de735b004b8e16b9a31d228c
Author: Eamon Walsh <ewalsh@tycho.nsa.gov>
Date:   Wed Jan 6 12:52:51 2010 -0500

    xselinux: Remove reference counting calls for SID objects.
    
    Starting with libselinux 2.0.86, SID objects are no longer
    reference counted and the sidput() and sidget() calls are no-ops.
    
    Signed-off-by: Eamon Walsh <ewalsh@tycho.nsa.gov>
    Reviewed-by: Keith Packard <keithp@keithp.com>

commit c030ec32b6418e6258b380c0e29971be882a84d4
[--snip--]
